# DOG

# DOG

For the latest information about DOG see the [DOG Operating Guide](https://dog.zumppe.net/)

## What is DOG?

![DOG logo](https://dog.zumppe.net/img/logo.png)

DOG is a DOS shell, or command interpreter. DOG works on most, if not all flavors
of DOS. I mainly target [FreeDOS](https://freedos.org/), but regularly test on
MS-DOS 3.30 and 6.22 and DR-DOS 6.0 and 7.02.

DOG works similar to COMMAND.COM or 4DOS, but is different. First and probably
most importantly DOG is **not** drop-in compatible with neither COMMAND.COM nor
4DOS.  DOG does things differently. Second difference is that DOG commands are
always just 2 letters, but still easy to remember. DOG also offers external
commands allowing them to be more complex, and keeping the core of DOG
smaller.

DOG has 2 classes of commands: INTERNAL and EXTERNAL. The internal commands are
built-in to the DOG.COM binary and are always in memory and access the internals
of DOG. There are 2 kinds of internal commands. Regular user commands and the
batch file programming commands. The external commands are stand-alone
executables, but considered to be part of DOG, and may access DOG internals where
needed through an API.


*  Syntax: `DOG [-P|-E envsz|-A aliassz|-C command line]`
*  Parameters:
   *  -P - Makes DOG a PERMANENT shell.
   *  -E envsz - Makes the environment to envsz bytes (divisible by 16).
   *  -A aliassz - Makes the alias space to aliassz bytes (divisible by 16).
   *  -C command line - Executes the command line and exits.

## A note about DOG version numbers

DOG uses the following version scheme:

```
0.8.4b
------
| | ||
| | |+-- Code maturity allways one of a (=alpha), b (=beta) OR f (=final)
| | +--- Patchlevel
| +----- Minor version
+------- Major version
```

This versioning scheme means that the maximum version of DOG will be
`15.15.15f`, in hex that will be `FFFFh`. So far DOG has only release
alpha before version 0.8 and beta releases after `0.8.0b`. The first
final version will be `1.0.0f`.

# Contributing

**Would you like to contribute to FreeDOS?** The programs listed here are a great place to start. Most of these do not have a maintainer anymore and need your help to make them better. Here's how to get started:

* __Maintainers__: Let us know if you'd like to take on one of these programs, and we can provide access to the source code repository here. Please use the FreeDOS package structure when you make new releases, including all executables, source code, and metadata.

* __New developers__: We can extend access for you to track issues here.

* __Translators__: Please submit to the [FD-NLS Project](https://github.com/shidel/fd-nls).

_*Make sure to check all source code licenses, especially for any code you might reuse from other projects to improve these programs. Note that not all open source licenses are the same or compatible with one another. (For example, you cannot reuse code covered under the GNU GPL in a program that uses the BSD license.)_

## DOG.LSM

<table>
<tr><td>title</td><td>DOG</td></tr>
<tr><td>version</td><td>0.8.5b</td></tr>
<tr><td>entered&nbsp;date</td><td>2024-11-25</td></tr>
<tr><td>description</td><td>An alternative command.com shell</td></tr>
<tr><td>summary</td><td>An alternative command.com shell.</td></tr>
<tr><td>keywords</td><td>command, shell</td></tr>
<tr><td>author</td><td>Wolf Bergenheim</td></tr>
<tr><td>maintained&nbsp;by</td><td>Wolf Bergenheim</td></tr>
<tr><td>primary&nbsp;site</td><td>https://dog.zumppe.net</td></tr>
<tr><td>alternate&nbsp;site</td><td>https://github.com/susi/dog</td></tr>
<tr><td>original&nbsp;site</td><td>https://sourceforge.net/projects/dog/files/dog/</td></tr>
<tr><td>platforms</td><td>DOS (Turbo C++ 1.01, ASM), FreeDOS</td></tr>
<tr><td>copying&nbsp;policy</td><td>[GNU General Public License, Version 2](LICENSE)</td></tr>
</table>
